/**
trace class extension written by Vu Duong <vu.duong@masterpiece-softworks.de>

:::How to use:::
Include this file to your flash to get access to the additional class methods.
To use all class extensions read the instruction in the flashclass_extension.as file
*/

trace("flashclass extension <trace> loaded");

_global.objectTrace = function(p_object, p_tab) {
	
	var tab = (p_tab == undefined) ? "  " : "  " + p_tab;
	
	for(var item in p_object) {
		
		var output = "[" + item + "]";
		
		if(typeof(p_object[item]) == "string") {
			
			output += ": " + p_object[item];
			trace(tab + output);

			
		} else {
			
			trace(tab + output + " =>");
			objectTrace(p_object[item], tab);
			trace(tab + "<=]");
		}

	}
	
}
