﻿/**
xml class extension written by Vu Duong <vu.duong@masterpiece-softworks.de>

:::How to use:::
Include this file to your flash to get access to the additional class methods.
To use all class extensions read the instruction in the flashclass_extension.as file
*/
trace("flashclass extension <xml> loaded");

System.useCodepage = true;

_global.loadXML = function(p_xmlOBJName, p_xmlFilename) {
	
	var levelInstance = this;
	this[p_xmlOBJName] = new XML();
	this[p_xmlOBJName].ignoreWhite = true;
	this[p_xmlOBJName].load(p_xmlFilename);
	this[p_xmlOBJName].onLoad = function(success) {
		
		this.XMLInitCmd();
		
	}
}

XML.prototype.XMLInitCmd = function() {
	
	this._parent.play();
	
}

Object.prototype.getNode = function(p_string) {
	
	var temp = false;
	for(var i=0; i<this.length; i++) {
		if(this[i].nodeName == p_string) {
			temp = this[i].childNodes;
			break;
		}
	}
	return temp;
	delete(temp);
	
}

Object.prototype.toArray = function() {
	
	var arr = [];
	var ref_arr = arr;
	var base = this.childNodes;
	
	checkNodes = function(p_base) {
		
		var node = p_base;
		var base_ref = ref_arr;
		for(var i = 0; i < node.length; i++) {
			
			if(node[i].nodeName != null) {
				if(node[i].nodeName == node[i - 1].nodeName || node[i].nodeName == node[i + 1].nodeName) {
					var __name = i;
				} else {
					var __name = node[i].nodeName;
				}
				
				if(node[i].firstChild.nodeValue != null) {
					
					var hasItems = false;
					for(var item in node[i].attributes) {
						hasItems = true;
						break;
					}
					if(hasItems) {
						ref_arr = base_ref[__name] = [];
						ref_arr.attribs = node[i].attributes;
						ref_arr.value = node[i].firstChild.nodeValue;
					} else {
						ref_arr = base_ref[__name] = node[i].firstChild.nodeValue;
					}
					
				} else {

					ref_arr = base_ref[__name] = [];
					
					var hasItems = false;
					for(var item in node[i].attributes) {
						hasItems = true;
						break;
					}
					if(hasItems) {
						ref_arr.attribs = node[i].attributes;
					}
					
				}
			}

			checkNodes(node[i].childNodes);
			
		}
	}
	checkNodes(base);
	trace("XML successfully turned into an array");
	return arr;
	
}

_global.getAttribs = function(p_source) {
	
	var arr = new Array();
	var dataRef_units = p_source;
	
	for(var i = 0; i < dataRef_units.length; i++) {
		
		var tmp = new Array();
		
		for(var item in dataRef_units[i]["attribs"]) {
			
			tmp[item] = dataRef_units[i]["attribs"][item];
			
		}
		
		arr.push(tmp);
		
	}
	
	return arr;
	
}

_global.getValues = function(p_source) {
	
	var arr = new Array();
	var dataRef_units = p_source;
	
	for(var i = 0; i < dataRef_units.length; i++) {
		
		arr.push(dataRef_units[i]["value"]);
		
	}
	
	return arr;
	
}

ASSetPropFlags(Object.prototype, "getNode", 1);
ASSetPropFlags(XML.prototype, "XMLInitCmd", 1);
ASSetPropFlags(Object.prototype, "toArray", 1);
